﻿namespace TabsStudioAvalonStyleEditor
{
    public class AvalonStyleEditor : TabsStudioExt.ITabsStudioAddin, TabsStudioExt.ICustomStyleEditor
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine, EnvDTE80.DTE2 dte)
        {
            System.AppDomain.CurrentDomain.AssemblyResolve += AssemblyResolve;
        }

        public void OnDisconnection()
        {
            System.AppDomain.CurrentDomain.AssemblyResolve -= AssemblyResolve;
        }

        public TabsStudioExt.IStyleEditor GetStyleEditor()
        {
            return new AvalonAdapter();
        }

        private System.Reflection.Assembly AssemblyResolve(object sender, System.ResolveEventArgs args)
        {
            if (args.Name.StartsWith("ICSharpCode.AvalonEdit"))
            {
                string addinsDirectory =
                    System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
                return System.Reflection.Assembly.LoadFrom(
                    System.IO.Path.Combine(addinsDirectory, "ICSharpCode.AvalonEdit.dll"));
            }
            return null;
        }
    }
}
