﻿namespace TabsStudioAvalonStyleEditor
{
    class BlockCommentRegion
    {
        public string CommentStart { get; private set; }
        public string CommentEnd { get; private set; }
        public int StartOffset { get; private set; }
        public int EndOffset { get; private set; }

        /// <summary>
        /// The end offset is the offset where the comment end string starts from.
        /// </summary>
        public BlockCommentRegion(string commentStart, string commentEnd, int startOffset, int endOffset)
        {
            this.CommentStart = commentStart;
            this.CommentEnd = commentEnd;
            this.StartOffset = startOffset;
            this.EndOffset = endOffset;
        }

        public override int GetHashCode()
        {
            int hashCode = 0;
            unchecked
            {
                if (CommentStart != null) hashCode += 1000000007 * CommentStart.GetHashCode();
                if (CommentEnd != null) hashCode += 1000000009 * CommentEnd.GetHashCode();
                hashCode += 1000000021 * StartOffset.GetHashCode();
                hashCode += 1000000033 * EndOffset.GetHashCode();
            }
            return hashCode;
        }

        public override bool Equals(object obj)
        {
            BlockCommentRegion other = obj as BlockCommentRegion;
            if (other == null) return false;
            return this.CommentStart == other.CommentStart &&
                this.CommentEnd == other.CommentEnd &&
                this.StartOffset == other.StartOffset &&
                this.EndOffset == other.EndOffset;
        }
    }
}
