﻿namespace TabsStudioAvalonStyleEditor
{
    class Model
    {
        public Model(ICSharpCode.AvalonEdit.TextEditor editor)
        {
            helper = new AvalonHelper(editor);
        }

        public void CommentUncomment()
        {
            helper.SurroundSelectionWithBlockComment("<!--", "-->");
        }

        public void PickColor()
        {
            BlockRegion caretQuote = helper.FindCaretQuotedRegion();
            System.Windows.Media.Color currentColor = System.Windows.Media.Colors.Black;
            bool replaceColor = false;
            if (caretQuote != null)
            {
                string textAroundCaret = helper.GetRegionText(caretQuote);
                try
                {
                    object caretColor = System.Windows.Media.ColorConverter.ConvertFromString(textAroundCaret);
                    if (caretColor != null && caretColor is System.Windows.Media.Color)
                    {
                        currentColor = (System.Windows.Media.Color)caretColor;
                        replaceColor = true;
                    }
                }
                catch (System.Exception)
                {
                }
            }
            ColorPickerDialog colorDialog = new ColorPickerDialog(currentColor);
            if ((bool)colorDialog.ShowDialog())
            {
                string newColor = ColorToString(colorDialog.NewColor);
                if (replaceColor)
                    helper.ReplaceRegion(caretQuote, newColor);
                else
                    helper.InsertText(newColor);
            }
        }

        private string ColorToString(System.Windows.Media.Color c)
        {
            if (c.A != 255)
                return string.Format("#{0:X2}{1:X2}{2:X2}{3:X2}", c.A, c.R, c.G, c.B);
            else
                return string.Format("#{0:X2}{1:X2}{2:X2}", c.R, c.G, c.B);
        }

        private AvalonHelper helper;
    }
}
