﻿namespace TabsStudioAvalonStyleEditor
{
    class UIHelper
    {
        public static void AddColumnDefinition(System.Windows.Controls.Grid grid, System.Windows.GridLength width)
        {
            System.Windows.Controls.ColumnDefinition c = new System.Windows.Controls.ColumnDefinition();
            c.Width = width;
            grid.ColumnDefinitions.Add(c);
        }

        public static System.Windows.Controls.Image LoadImage(string resource)
        {
            System.Windows.Controls.Image result = new System.Windows.Controls.Image();
            result.Source = new System.Windows.Media.Imaging.BitmapImage(
                new System.Uri("pack://application:,,,/AvalonStyleEditor;component/Resources/" + resource));
            return result;
        }

        public static string LoadString(string resource)
        {
            using (System.IO.Stream stream = System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(
                "AvalonStyleEditor.Resources." + resource))
            {
                using (System.IO.StreamReader reader = new System.IO.StreamReader(stream))
                {
                    return reader.ReadToEnd();
                }
            }
        }

        public static System.Windows.ResourceDictionary CreateResources(string style)
        {
	        string header = 
		        "<ResourceDictionary " +
                "xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" " +
                "xmlns:s=\"clr-namespace:System;assembly=mscorlib\" " +
		        "xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\" " +
                ">";
	        string footer = "</ResourceDictionary>";

	        System.IO.StringReader stringReader = new System.IO.StringReader(header + style + footer);
	        System.Xml.XmlTextReader xmlTextReader = new System.Xml.XmlTextReader(stringReader);
	        object o = System.Windows.Markup.XamlReader.Load(xmlTextReader);
	        return (System.Windows.ResourceDictionary)o;
        }

        public static System.Windows.Controls.Button CreateToolbarButton(string image, string tooltip)
        {
            System.Windows.Controls.Button button = new System.Windows.Controls.Button();
            button.Content = UIHelper.LoadImage(image);
            button.ToolTip = tooltip;
            System.Windows.Controls.ToolTipService.SetShowOnDisabled(button, true);
            return button;
        }
    }
}
